import pygame


class Camera:
    def __init__(self, game):
        self.game = game
        self.map = game.map
        self.player = game.player
        self.enemies = game.enemies
        self.projectiles = game.projectiles
        self.settings = game.settings

        self.map.add_enemies(self.enemies)
    
    def move_up(self):
        self.map.move_up()
        self.player.move_up()

    def move_down(self):
        self.map.move_down()
        self.player.move_down()

    def move_left(self):
        self.map.move_left()
        self.player.move_left()

    def move_right(self):
        self.map.move_right()
        self.player.move_right()
    
    def update(self):
        keystate = pygame.key.get_pressed()

        if keystate[pygame.K_w]:
            self.move_up()
        elif keystate[pygame.K_a]:
            self.move_left()
        elif keystate[pygame.K_s]:
            self.move_down()
        elif keystate[pygame.K_d]:
            self.move_right() 
