import os
import sys
import pygame

class GameSettings:
    def __init__(self):
        self.screen_height = 640
        self.screen_width = 1024
        self.c_x = self.screen_width // 2
        self.c_y = self.screen_height // 2
        self.fps = 30
        self.caption = "TankiOffline"
        self.running = True

        self.path_separator = os.sep
        self.img_folder = os.path.join(os.path.realpath(sys.argv[0]).rsplit(os.sep, 1)[0], 'sprites')
        self.map_folder = os.path.join(os.path.realpath(sys.argv[0]).rsplit(os.sep, 1)[0], 'maps')
        self.move_speed = 60 / self.fps

        self.block_size = 64
        self.entity_size = 60

        self.projectile_size = 20
        self.projectile_speed = 240 / self.fps
        self.recharge_time = 0.5

        self.enemy_spawn_rev = 6000 / self.fps
        self.enemy_spawn_rev_thresh = 30
        self.enemy_spawn_rev_delta = 0.001
        self.enemy_shot_rev = 1200 / self.fps


